# -*- coding: utf-8 -*-

#!/usr/bin/env python

'''wmhalt.py

WindowMaker dockapp that halt reboot or lock screen.

Copyright (C) 2010 Konstantin Kogan and Vladimir Gusev.

Licensed under the GNU General Public License.

'''

import sys
import time
import getopt
import os
import Tkinter as tk
from Tkinter import *
import pywmhelpers

width = 64
height = 64


lettersStartX = 0
lettersStartY = 74
letterWidth = 6
letterHeight = 8

digitsStartX = 0
digitsStartY = 64
digitWidth = 6
digitHeight = 8

xOffset = 4
yOffset = 4

letters = 'abcdefghijklmnopqrstuvwxyz'
digits = '0123456789:/- '

flg = 1
xs = 57
ys = 57
def reb(event):
    os.system('reboot')
    
def slock(event):   
    os.system('xscreenlock')
    
def halt(event):
	os.system('halt')


defaultRGBFiles = ['/usr/lib/X11/rgb.txt', '/usr/X11R6/lib/X11/rgb.txt']
maxCharsPerLine = 9

def checkForEvents():
        '''Check for, and handle, X events.'''
        global flg
        
        event = pywmhelpers.getEvent()
        while not event is None:
            if event['type'] == 'buttonrelease':
                
				if flg == 1:				
				   flg = 0
				else:
				   flg = 1

            elif event['type'] == 'destroynotify':
                sys.exit(0)
            event = pywmhelpers.getEvent()




def mainLoop(): # Основной цикл программы
    root = Tk()
    root.title("")
    root.minsize(width=3*xs+24,height=67)
    root.maxsize(width=3*xs+24,height=67)
    print root.winfo_screenwidth(), root.winfo_screenheight()

    x = root.winfo_screenwidth()/2
    y = root.winfo_screenheight()/2
    x = x - 100
    y= y - 32
    s = '400x300+'+str(x)+'+'+str(y)
    root.attributes("-zoomed")

    fr=Frame(root, width=3*xs+24, height=67, bg='#888888')
    fr.place(x='0',y='0')
    root.geometry(s)
    root.transient()


    button1 = tk.Button(root,width=xs,height=ys)
    img1 = PhotoImage(file = 'Data/shutdown_48.gif')
    button1["image"] = img1
    button1.place(x='2',y='2')
    button1.bind("<Button-1>", halt )

    button2 = tk.Button(root,width=xs,height=ys)
    img2 = PhotoImage(file = 'Data/reboot_48.gif')
    button2["image"] = img2
    button2.place(x='66',y='2')
    button2.bind("<Button-1>", reb )

    button3 = tk.Button(root,width=xs,height=ys)
    img3 = PhotoImage(file = 'Data/lock_48.gif')
    button3["image"] = img3
    button3.place(x='130',y='2')
    button3.bind("<Button-1>", slock)

    root.lift()
    root.bind('<Escape>',exit)
    root.overrideredirect(1)
    while 1:
		if flg ==1:
			root.withdraw()
		else:
			root.deiconify()	
		root.update()
		checkForEvents()    
		pywmhelpers.redraw()
		time.sleep(0.1)
		
		
def parseColors(defaultRGBFileNames, config, xpm):
    rgbFileName = ''
    for fn in defaultRGBFileNames:
        if os.access(fn, os.R_OK):
            rgbFileName = fn
            break
    rgbFileName = config.get('rgbfile', rgbFileName)
    useColors = 1
    if not os.access(rgbFileName, os.R_OK):
        sys.stderr.write(
            "Can't read the RGB file, try setting it differently using -r,\n")
        sys.stderr.write(
            "Ignoring your color settings, using the defaults.\n")
        useColors = 0
    if useColors:
        # Colors is a list with (<config_key>, <xpm-key>) pairs.
        colors = (('foreground', 'text'),
                  ('background', 'background'))
        for key, value in colors:
            col = config.get(key)
            if not col is None:
                code = pywmhelpers.getColorCode(col, rgbFileName)
                if code is None:
                    sys.stderr.write('Bad colorcode for %s, ignoring.\n' % key)
                else:
                    pywmhelpers.setColor(xpm, value, code)

def main():
	
	pywmhelpers.setDefaultPixmap(xpm)
    #timeFmt = config.get('timeformat', timeDefaultFormat)
    
	programName = ''
	sys.argv[0] = programName
    #pywmhelpers.setDefaultPixmap(xpm)
	pywmhelpers.openXwindow(sys.argv, width, height)
	pywmhelpers.copyXPMArea(62,0,0,0,0,0)
        
	
	mainLoop()
xpm = \
['160 100 18 1',
'  c #00A500A500A5',
'. c #164816481648',
'X c #209520952095',
'o c #375437543754',
'O c #47F247F247F2',
'+ c #57AA57AA57AA',
'@ c #67E767E767E7',
'# c #77D077D077D0',
'$ c #00000000FFFF',
'% c #2020B2B2AD0B',
'& c #886688668866',
'* c #944694469446',
'= c #A7C8A7C8A7C8',
'- c #B85EB85EB85E',
'; c #C939C939C939',
': c #DA06DA06DA06',
'> c #E7B2E7B2E7B2',
', c #F714F714F714',
'                                                                 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&     $%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &&******************************&*********************&&     $%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::::::::::::::::::::::::::::::::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$o$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::::::::::::::::::::>::::::::::::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::>::::>:::::::::::::::::::::::::>::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::::::::::::;;;====*=-;;:::::::::::::::::>::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::>:::::::::::::;=&#++OOO+++##*-;:::>::::::>::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::::::::-&+OoOO++@@@@@++++@=;:::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::::::;*+ooO+@@@####&&&&&#+O@-::::::::::>:::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::::::-@ooo++++@@@##&&&**&*&@OO&:::::>:::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::::-OooO+++@@@@@###&&&*****#+o+::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::>:::>::-OooOOO+++@@####&&&&&**&&&#+++;::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::=o.oOOO@&#@@@@###&&&&&&**&&##+++;:::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::;oooOOO#-;;=@@#@####&&&-::-&@@+O.@:::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::>:::::;+.ooOO&;:::;&@@#######=:::>;&+@Oo.&:>::>:::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::#.ooOO&;:;:::&@#@@###&#*>::::;&+Oo.o=::::::>*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::=ooooO#;;::::-#+@####&##&;:::::-@....@;::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::@ooOo+-;:::;=@+@@@@@@@###*;:::;;&....o=::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::-ooOoo*::::;=@+@+@@@@#@#@#@&-:;;;;O....@::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:>::::&ooOo@;::;;*++++@@@#&#@@@@@@#-;;;;=....o=:::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::;+OOoo=:;:;=@++++++&-;*#@@@@+o@--;--+....&:::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::=ooOo+;;:;;&OOO+++@;:::=+@+Oo..&;;;;#....+;:::>*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::>&ooO #;:;:-+O+++++@:::>;++Oo...+-;-;=....O-:>::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::#oOOo*;;:;*OOOOO++#:>>>;O+o.....=;;;-o...o=::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::;@OOoo=;::;&oOOOO+O#:>>>;Oo......&;;;;+...o*:>::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::;+oOoo=;::;@OOOOOOO@:>>>:o.......#;;;-@....*::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::;+oOoo-:::;+oOOOOOO@>>>>;........@;:;;#...o&::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::;+o+oo-:::;@ooOoOOo@>,,>;........@;;;;#....&::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::;@o+oo=::>;@ooOoOOO+>,,>;........&;:;;@...o*::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::@o+o =::>:* oooooo@>,,,;........->::;+...o*::::*&     O%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::>::&o@O &::>>-Ooooooo@,,,,;.......O;>::;....O-::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::*o++ +;>>>;@ooooOoO>,,,-.......&:>::=....+-::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%+$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::-OO@oo->>>>=oooooo *>,:+......O;>>>:#....#;:>::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::@O#o.&>>,>:&o ooo.o#*+.......*>>>>;o...o*:::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::>::=O@@ o;,>,,:#oo.............&>,,,,&....O;:::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::;+@#o.#>>,,,;&o...........o&>,,,,;...oo&::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::>::&+#@ o=>,,,,>=O ........@->,,,,>+..OoO;::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::;+@&+.o-,,,,,>;*#+OOO+#=;>>,,,,&..oO &;::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:>::::::=o#&O.O=,,,,,>>;;---;;>>>>>,>&..oO +;:::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::*O*&o.O=,,,>>>>>::::::::>>:@..o+oo;::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::#O=&O.o&;,>>>::::::;;:>:*+..o@oo=:::::::>:*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::::@o=&@..o#:>:::;;;;:::=O...+#o.*::::>:::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::>:::::>#O*=&o...O*------*@ ...O#@oo::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::::::&+#*=&Oo...oooo.....O#&+oO-::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::>:::-@+*==*&+o.....o+#&&#oo#;:::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::::::::;&+#&&*=-======&#@+o@-:::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::::::::;:-&@+@@@@#@@+++++@*;:;;::;::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%O$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::;;;;------=*&@+OOOOO+@&*==---;-;;;;::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::>:::;;;;---===*=*****&&&**&**=*===---;;;;:::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::;;;;;-;----============----;-;;;;;::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*:::::::::::::::::;;:;;;;;:;;;;;;;:;:;:::::>:::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::::::::::::>>::::::::>:::>:::::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::>::::::::>:::::>:::::::::::::::::>::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &*::::::::::::::::::::::::::::::::::::::::::::::::::::*&     $%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &&****************************************************&&     $%%%%%%%%%%%%%%+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'    &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&     $%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                      $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                      $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                                                                                    $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
' %%%%%   %   %%%%% %%%%% %   % %%%%% %%%%% %%%%% %%%%% %%%%%          %          % %                                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
' %   %  %%       %     % %   % %     %         % %   % %   %  %%      %            %                                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
' %   %   %       %     % %   % %     %         % %   % %   %  %%     %%           %%                                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
' %   %   %   %%%%%  %%%% %%%%% %%%%% %%%%%     % %%%%% %%%%%         %   %%%%%    %                                                 $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
' %   %   %   %         %     %     % %   %     % %   %     %        %%           %%                                                 $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
' %   %   %   %         %     %     % %   %     % %   %     %  %%    %            %     %%                                           $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
' %%%%%  %%%  %%%%% %%%%%     % %%%%% %%%%%     % %%%%% %%%%%  %%    %            % %   %%                                           $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                                                                                    $$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'                                                                                                                                                                ',
'  %%%  %%%%   %%%% %%%%  %%%%  %%%%% %%%%% %   %   %       % %   % %     %   % %%%%  %%%%% %%%%% %%%%% %%%%% %%%%% %%%%% %   % %   % %   % %   % %   % %%%%%    ',
' %   % %   % %     %   % %     %     %     %   %   %       % %   % %     %% %% %   % %   % %   % %   % %   % %       %   %   % %   % %   % %   % %   %     %    ',
' %   % %   % %     %   % %     %     %     %   %   %       % %  %  %     % % % %   % %   % %   % %   % %   % %       %   %   % %   % %   %  % %  %   %    %     ',
' %%%%% %%%%  %     %   % %%%%  %%%%  % %%% %%%%%   %       % %%%   %     %   % %   % %   % %%%%% %%  % %%%%  %%%%%   %   %   % %   % %   %   %   %%%%%   %      ',
' %   % %   % %     %   % %     %     %   % %   %   %       % %  %  %     %   % %   % %   % %     % % % %   %     %   %   %   % %   % % % %  % %      %  %       ',
' %   % %   % %     %   % %     %     %   % %   %   %   %   % %   % %     %   % %   % %   % %     %  %% %   %     %   %   %   % %   % %% %% %   %     % %        ',
' %   % %%%%   %%%% %%%%  %%%%  %     %%%%% %   %   %    %%%  %   % %%%%  %   % %   % %%%%% %     %%%%% %   % %%%%%   %    %%%%  %%%  %   % %   % %%%%% %%%%%    ',
'                                                                                                                                                                ',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$',
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
];



if __name__ == '__main__':
    main()

